# App for drilling addition problems

Uses sudoku-like "sum grid" puzzles.

![demo](assets/1.gif)

This repo is an example of a [Freewheeling App](http://akkartik.name/freewheeling),
designed above all to be easy to run, easy to modify and easy to share.

## Getting started

Install [LÖVE](https://love2d.org). It's just a 5MB download, open-source and
extremely well-behaved. I'll assume below that you can invoke it using the
`love` command, but that might vary depending on your OS.

Run this app from the terminal, [passing its directory to LÖVE](https://love2d.org/wiki/Getting_Started#Running_Games)

## Hacking

To modify it live without restarting the app each time, download [the driver
app](https://git.sr.ht/~akkartik/driver.love). Here's an example session
using a different freewheeling app:

![making changes without restarting the app](assets/2.gif)

[Some reference documentation on how to create your own apps.](reference.md)

If you run a .love file, your changes will go into the [save directory](https://love2d.org/wiki/love.filesystem.getSaveDirectory).
If you unzip the .love file into a new directory and run the directory
instead, your changes will go straight into the same directory.

## Keyboard shortcuts

* `ctrl+n` to generate a new problem
* `\`` to reveal/hide the solution (I should probably disable this before
  putting it in front of the kids.)

Exclusively tested so far with a US keyboard layout. If
you use a different layout, please let me know if things worked, or if you
found anything amiss: http://akkartik.name/contact

## Known issues

* Both freewheeling apps and the driver for them currently benefit from being
  launched in terminal windows rather than by being clicked on in a desktop
  OS. See [the driver app](https://git.sr.ht/~akkartik/driver.love/src/branch/main/README.md)
  for details.

## Mirrors and Forks

This repo is a fork of [lines.love](http://akkartik.name/lines.html), an
editor for plain text where you can also seamlessly insert line drawings.
Its immediate upstream is [the template repo for freewheeling apps](https://git.sr.ht/~akkartik/template-live-editor).
Updates to it can be downloaded from the following mirrors:

* https://git.sr.ht/~akkartik/sum-grid.love
* https://nest.pijul.com/akkartik/sum-grid.love (using the Pijul version control system)

Further forks are encouraged. If you show me your fork, I'll link to it here.

## Feedback

[Most appreciated.](http://akkartik.name/contact)
